//******************************************************************************
//
//   VU_LEDS
//
//   AUTOR: CLAUDIO LARIOS         DATA:09-05-2014
//
//   OBJETIVO: GERAR UM VU USANDO UM PIC 12F675 LIGADO A 12 LEDS
//
//   FUNCIONA EM MODO BARRA OU PONTO (ATERRANDO O PINO 4=PONTO)
//   USO: INDICAO DE NVEIS SONOROS, LIQUIDOS, EFEITOS,ETC
//   MONTAGEM APENAS DIDTICA.
//   SUJEITA A BUGS AINDA NO DETECTADO.
//
//******************************************************************************

//      #define PERDI_BYTE_CALIBRACAO
#include <12F675.h>         // includes

#ignore_warnings 203   //desconsidera mensagem de 'condition always true'

#fuses INTRC_IO,NOWDT,NOPROTECT, NOMCLR ,BROWNOUT, PUT  // palavra  configurao
#use delay(clock=4000000)  // clock para 4 mhz
#use fast_io(A)  //  sentido das portas feita pelo programador

#ifdef  PERDI_BYTE_CALIBRACAO  // calibrao do oscilador interno do pic
#ROM  0X3FF = {0X34FC}//mxima freq= 0x34fc ;mdia=0x3480; minima=0x3400
#endif

#byte   gpio = 0X05
#byte   tris = 0X85
#bit    mode = 0x05.3  
//tabelas
int const v_gpio[]={2,1,32,2,16,32,1,32,2,16,1,16};
int const v_tris[]={60,60,29,29,15,15,30,30,45,45,46,46};

int const vin_max = 5; //tenso para acender o ultimo led (use inteiro apenas)
int const vpled= (255*vin_max)/60;

//VARIAVIS GLOBAIS
int valor;

//==============================================================================
//               rotina main
//==============================================================================
Void Main (){
      tris=0b111111; //direo das portas (tudo entrada)
      setup_comparator(NC_NC_NC_NC);// desliga comparadores analgicos
      setup_adc_ports(sAN2 | VSS_VDD);  //seleciona AN2 e 5v como referncia
      setup_adc(ADC_CLOCK_DIV_8 );// ajusta o clock do adc
      set_adc_channel(2); //ajusta para o pino 5 (AN2)
      delay_us(10); //delay

    //  valor=0;
//==============================================================================
//       loop principal

   While (true) {
   int a;
   short flag=0;

    valor = READ_ADC();// l valor da tenso de entrada do pino 5

    if(valor) {valor=valor/vpled;}// divide por 21 para selecionar led correto
    if(valor>11) valor=11;// evita erros ao buscar tabela
    
    if(mode){ //PINO 4='1'->BARRA
      for(a=0;a<12;++a){
         tris=0b111111; //apaga leds para mudana
          if(!flag){
            gpio=v_gpio[valor];// prepara a sada de valores
            tris=v_tris[valor];// libera com sentido das portas de entradas para sadas
         }
         else{ delay_us(40);}
            delay_ms(3);// tempo que o led ficar aceso
            if(--valor==0xff) { flag=1;}
      }
    }
    else{ //PINO 4= '0' ->PONTO
     tris=0b111111; //apaga leds para mudana
     gpio=v_gpio[valor];// prepara a sada de valores
     tris=v_tris[valor];// libera com sentido das portas de entradas para sadas
     delay_ms(100);// tempo que o led ficar aceso
     }
    

   }//   WHILE (TRUE)
}//VOID MAIN
